.386    
.model      flat, stdcall
option      casemap:none

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\ole32.inc

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\ole32.lib

DlgProcedure	PROTO :DWORD, :DWORD, :DWORD, :DWORD
ShowTab PROTO :DWORD,:DWORD

    str$ MACRO DDvalue
      LOCAL rvstring
      .data
        rvstring db 20 dup (0)
        align 4
      .code

PUSH  offset rvstring
PUSH  DDvalue
CALL  dwtoa

      EXITM <ADDR rvstring>
    ENDM


.Const
BTN_ONE         equ 101
IDC_EDIT        equ 102
BTN_TWO         equ 103


Unknown STRUCT
	QueryInterface     DWORD	?
	AddRef             DWORD	?
	Release            DWORD	?
Unknown ends

ITaskbarList STRUCT
	IUnknown		Unknown		<>
	
	HrInit			DWORD	?
	AddTab			DWORD	?
	DeleteTab		DWORD	?
	ActivateTab		DWORD	?
	SetActiveAlt		DWORD	?
ITaskbarList ends

.const
sCLSID_TaskbarList	textequ	<{056fdf344H, 0fd6dH, 011D0H,\
		{095H, 08ah, 000H, 060H, 097H, 0c9H, 0a0H, 090H}}>

sIID_ITaskbarList	textequ	<{056FDF342H, 0FD6DH, 011D0H,\
		{095H, 08AH, 000H, 060H, 097H, 0C9H, 0A0H, 090H}}>

.Data

szDlg       db  "DLG", 0
szTest      db  "TEST", 0

CLSID_ITaskbarList      GUID        sCLSID_TaskbarList
IID_ITaskbarList        GUID        sIID_ITaskbarList


.Data?
 hInst      HINSTANCE ?

.Code                                 
 Start:            

invoke GetModuleHandle, NULL
mov hInst, eax
invoke DialogBoxParam, hInst, addr szDlg, 0, addr DlgProcedure, 0


; invoke CoInitialize,NULL        ;    !!!

;invoke InitCommonControls
;invoke CoUninitialize           ;    !!!

	invoke ExitProcess, NULL

; ########################################################  
; ########################################################  

DlgProcedure Proc uses esi edi hDlg:DWORD,uMsg:DWORD,
                                wParam:DWORD,lParam:DWORD
	.if uMsg==WM_INITDIALOG
;		invoke GetWindowRect, hDlg, addr rect
	.elseif uMsg==WM_CLOSE
		xor eax, eax
		invoke EndDialog, hDlg, NULL
	.elseif uMsg==WM_COMMAND
		.if wParam!=0
			mov eax, wParam
			mov edx, wParam
			shr edx, 16

            .if dx==BN_CLICKED
; .........................................
            .if ax==BTN_ONE

PUSH  0                         ;  H I D E
PUSH  hDlg
CALL  ShowTab
invoke CoUninitialize           ;  !!!

    .endif
; .........................................
            .if ax==BTN_TWO

PUSH  1                         ;  S H O W
PUSH  hDlg
CALL  ShowTab
invoke CoUninitialize           ;  !!!

.endif
; .........................................
	.endif
		.endif
	.else
		mov eax, FALSE
		ret
	.endif
	mov eax,TRUE
	ret
DlgProcedure EndP

; ########################################################  
; ########################################################  

ShowTab proc hWnd:DWORD,fShow:DWORD
	LOCAL ptb		:DWORD

invoke CoInitialize, 0          ;  !!!

invoke CoCreateInstance,ADDR CLSID_ITaskbarList,NULL,CLSCTX_INPROC_SERVER,\
		ADDR IID_ITaskbarList,ADDR ptb

;    PUSH  ptb                           ;  ADDR ptb      
;    PUSH  offset IID_ITaskbarList       ;  GUID
;    PUSH  1                             ;  CLSCTX_INPROC_SERVER
;    PUSH  0                             ;  NULL
;    PUSH  offset CLSID_ITaskbarList     ;  GUID 
;    CALL  CoCreateInstance
; .........................................
	.IF eax != S_OK
		mov eax,-1
		ret
	.endif

	push ptb
	mov edi,ptb
	mov edi,[edi]
	call [edi].ITaskbarList.HrInit
; .........................................
; .........................................
	.IF eax != S_OK
		push ptb
		call [edi].ITaskbarList.IUnknown.Release
		mov eax,-1
		ret
	.endif

	push hWnd        ; ...............  how is this possible
	push ptb         ; ...............  between .endif - .IF
; .........................................
	.IF fShow
		call [edi].ITaskbarList.AddTab

	.ELSE
		call [edi].ITaskbarList.DeleteTab

	.ENDIF
; .........................................

	.IF eax != S_OK
		push ptb
		call [edi].ITaskbarList.IUnknown.Release
		mov eax,-1
		ret
	.endif

	push ptb
	call [edi].ITaskbarList.IUnknown.Release

	xor eax,eax
   ; invoke MessageBox, 0, str$ (eax),  0, 0

	ret
ShowTab endp


End Start